/* Problem URL: https://codeforces.com/problemset/problem/2068/F */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 0

void solve()
{
    int n;
    cin >> n;
    V<string> a(n);
    cin >> a;

    string s;
    cin >> s;

    auto issub = [&](string &a, string &b) {
        int i = 0;
        rep(j, a.size()) {
            if (a[j] == b[i]) {
                i++;
                if (i == b.size()) {
                    return true;
                }
            }
        }

        return false;
    };

    vvi pos(26);
    vi ind(n);

    rep(i, n) {
        if (issub(a[i], s)) {
            cout << "NO\n";
            return;
        }

        pos[a[i][0] - 'a'].push_back(i);
    }

    cout << "YES\n";

    string ans;

    auto prall = [&](int j) {
        vi tmp;
        swap(tmp, pos[j]);
        ans.push_back(j + 'a');

        while (!tmp.empty()) {
            int i = tmp.back();
            tmp.pop_back();
            ind[i]++;
            if (ind[i] < a[i].size()) {
                pos[a[i][ind[i]] - 'a'].push_back(i);
            }
        }
    };

    repv(now, s) {
        int inv = now - 'a';
        rep(j, 26) {
            if (j == inv || pos[j].empty()) {
                continue;
            }

            prall(j);
            j = -1;
        }

        if (!pos[inv].empty()) {
            prall(inv);
        }
    }

    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
